subroutine filein(tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl &
     ,file9,iflag)
  use constants; use mympitools; use division; use mesh
!**********************************************************************
!     input data
!     iflag=1 when each process reads *own* data for *all* arrays
!     iflag=2 when each process reads *all* data for *each* array
!     otherwise    each process reads *all* data for *all* arrays
!**********************************************************************
  implicit none

  real(dp),dimension(ista:iend,jsta:jend,ksta:kend) :: &
       tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl
  integer :: iflag
  character(*) :: file9
!
!     read file9
!
  if (iflag == 1) then
     open(9,file=file9,status="old",form="unformatted")
     call filein9_1(tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl)
     close(9)
  else if (iflag == 2) then
     call filein9_2(tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl,file9)
  else
     open(9,file=file9,status="old",form="unformatted")
     call filein9_0(tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl)
     close(9)
  endif
!
  return

contains

! ---------------------------------------------------------------------

  subroutine filein9_0(tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl)
    implicit none

    integer :: i,j,k
    real(dp),dimension(ista:iend,jsta:jend,ksta:kend) :: &
         tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl
    real(dp),dimension(:,:,:,:),allocatable :: buff

    allocate(buff(iax,jax,kax,9))
    read(9)buff !     read(9)tmp,u,v,w,p,q,siv,eiv,visc

!     replace arrays
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             tmpl(i,j,k) = buff(i,j,k,1)
             ul(i,j,k) = buff(i,j,k,2)
             vl(i,j,k) = buff(i,j,k,3)
             wl(i,j,k) = buff(i,j,k,4)
             pl(i,j,k) = buff(i,j,k,5)
             ql(i,j,k) = buff(i,j,k,6)
             sivl(i,j,k) = buff(i,j,k,7)
             eivl(i,j,k) = buff(i,j,k,8)
             viscl(i,j,k) = buff(i,j,k,9)
          end do
       end do
    end do

    deallocate(buff)

    return
  end subroutine filein9_0

! ---------------------------------------------------------------------

  subroutine filein9_1(tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl)
    implicit none

    integer istad,iendd,jstad,jendd,kstad,kendd,idiff2
    real(dp),dimension(ista:iend,jsta:jend,ksta:kend) :: &
         tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl
!
    read(9)istad,iendd,jstad,jendd,kstad,kendd &
         ,tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl
!
    idiff2 = (istad-ista)**2+(iendd-iend)**2 &
         +(jstad-jsta)**2+(jendd-jend)**2 &
         +(kstad-ksta)**2+(kendd-kend)**2
    if (idiff2.ne.0) then
       write(*,'("Partitioning Mismatch for rank ",i)')myrank
       write(*,'(4x,6a5)')"ista","iend","jsta","jend","ksta","kend"
       write(*,'("In :",6i5)')istad,iendd,jstad,jendd,kstad,kendd
       write(*,'("Out:",6i5)')ista,iend,jsta,jend,ksta,kend
       stop
    endif
!
    return
  end subroutine filein9_1
! ---------------------------------------------------------------------

  subroutine filein9_2(tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl,file9)
    implicit none

    integer :: i,j,k,ij
    real(dp),dimension(ista:iend,jsta:jend,ksta:kend) :: &
         tmpl,ul,vl,wl,pl,ql,sivl,eivl,viscl
    real(dp),dimension(:,:,:),allocatable :: indat
    integer,parameter :: nvalues=9
    character(*) :: file9
    character(80) :: input_file
    character(1),dimension(nvalues) :: head
!
    head = (/ "t","u","v","w","p","q","s","e","h" /)
    allocate(indat(iax,jax,kax))

!     read(9)tmp,u,v,w,p,q,siv,eiv,visc

    input_file = "t"//file9
    open(31,file=input_file,status="old",form="unformatted")
    read(31)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             tmpl(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    input_file = "u"//file9
    open(32,file=input_file,status="old",form="unformatted")
    read(32)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             ul(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    input_file = "v"//file9
    open(33,file=input_file,status="old",form="unformatted")
    read(33)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             vl(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    input_file = "w"//file9
    open(34,file=input_file,status="old",form="unformatted")
    read(34)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             wl(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    input_file = "p"//file9
    open(35,file=input_file,status="old",form="unformatted")
    read(35)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             pl(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    input_file = "q"//file9
    open(36,file=input_file,status="old",form="unformatted")
    read(36)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             ql(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    input_file = "s"//file9
    open(37,file=input_file,status="old",form="unformatted")
    read(37)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             sivl(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    input_file = "e"//file9
    open(38,file=input_file,status="old",form="unformatted")
    read(38)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             eivl(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    input_file = "h"//file9
    open(39,file=input_file,status="old",form="unformatted")
    read(39)indat
    do k = ksta,kend
       do j = jsta,jend
          do i = ista,iend
             viscl(i,j,k) = indat(i,j,k)
          end do
       end do
    end do

    close(31); close(32); close(33); close(34); close(35); close(36)
    close(37); close(38); close(39)
    deallocate(indat)
!
    return

  end subroutine filein9_2

end subroutine filein
