subroutine fileout11(ntime,time,tmpl,ul,vl,wl,schl,sivl,eivl,viscl,iflag)
  use constants; use mympitools; use division; use mesh
!**********************************************************************
!     output data to file11
!     iflag=0 when root process writes all data
!     iflag=1 when each process writes own data
!**********************************************************************
  implicit none

  integer :: ntime
  real(dp),intent(in) :: time
  integer,intent(in) :: iflag
  real(dp),dimension(ista:iend,jsta:jend,ksta:kend),intent(in) :: &
       tmpl,ul,vl,wl,schl,sivl,eivl,viscl
  integer :: fileid

! output to file11 (ascii out)

  select case (iflag)
  case default
     call fileout11_0(ntime,time &
          ,tmpl,ul,vl,wl,schl,sivl,eivl,viscl)
  case (1)
     call fileout11_1(ntime,time &
          ,tmpl,ul,vl,wl,schl,sivl,eivl,viscl)
  end select

  return

contains
! ---------------------------------------------------------------------
  subroutine fileout11_0(ntime,time &
       ,tmpl,ul,vl,wl,schl,sivl,eivl,viscl)
!**********************************************************************
!     output temperature field
!**********************************************************************
    implicit none

    integer :: i,j,k,ijk
    integer,intent(in) :: ntime
    real(dp) time
    real(dp),dimension(ista:iend,jsta:jend,ksta:kend) :: &
         tmpl,schl,ul,vl,wl,sivl,eivl,viscl
    real(dp),dimension(:,:,:),allocatable :: tmp

    allocate(tmp(iax,jax,kax))
    call mygather123lg(tmpl,tmp,ista,iend,jsta,jend,ksta,kend,iax,jax,kax)

    if (myrank == 0) then
       write(11,*)ntime,time
       ! write(11,511)tmp,u,v,w,sch,siv,eiv,visc
       write(11,'(10f8.5)')tmp
    endif

    deallocate(tmp)

    return
  end subroutine fileout11_0
! ---------------------------------------------------------------------
  subroutine fileout11_1(ntime,time &
       ,tmpl,ul,vl,wl,schl,sivl,eivl,viscl)
!**********************************************************************
!**********************************************************************
    implicit none

    integer :: ntime
    real(dp) time
    real(dp),dimension(ista:iend,jsta:jend,ksta:kend) :: &
         tmpl,ul,vl,wl,schl,sivl,eivl,viscl
    write(11,*)ntime,time
    write(11,*)ista,iend,jsta,jend,ksta,kend
    ! write(11,511)tmpl,ul,vl,wl,schl,sivl,eivl,viscl
    write(11,'(10f8.5)')tmpl

    return
  end subroutine fileout11_1
end subroutine fileout11
