subroutine tstep(u,v,w,siv,eiv,crmax,dt)
  use constants; use mesh; use mympitools; use division
!**********************************************************************
!     calculate time step
!**********************************************************************
  implicit none

  integer :: i,j,k
  real(dp),dimension(ista:iend,jsta:jend,ksta:kend),intent(in) :: u,v,w,siv,eiv
  real(dp),intent(out) :: dt
  real(dp) :: dtd,dtd1,dta,dta1,dtai,crmax

! --------------------------------------
!     courant condition of advection
! --------------------------------------

  dtai = 0.e0_dp
  do k = ksta2,kend1
     do j = jsta2,jend1
        do i = ista3,iend1
           dta1 = dabs(u(i,j,k))/dxs(i)
           dtai = dmax1(dtai,dta1)
        end do
     end do
  end do
  do k = ksta2,kend1
     do j = jsta3,jend1
        do i = ista2,iend1
           dta1 = dabs(v(i,j,k))/dys(j)
           dtai = dmax1(dtai,dta1)
        end do
     end do
  end do
  do k = ksta3,kend1
     do j = jsta2,jend1
        do i = ista2,iend1
           dta1 = dabs(w(i,j,k))/dzs(k)
           dtai = dmax1(dtai,dta1)
        end do
     end do
  end do
  call mpi_allreduce(dtai,dta1,1,mpi_double_precision,mpi_max, &
       mpi_comm_world,ierr)
  dta = 1.e0/dta1

! ---------------------------------------
!     courant condition for diffusion
! ---------------------------------------

  dtd = 0.5e0*dxyzmin**2

! ------------------------
!     actual time step
! ------------------------

  dt = crmax*dmin1(dta,dtd)

!      write(*,'(6a11)')"dt","CrMax","dta","dtd"
!      write(*,'(6e11.4)')dt,CrMax,dta,dtd

  return
end subroutine tstep
